-- Main.lua
-- written by Habna


import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

Version = Plugins["TitanBar"]:GetVersion(); --> ** TitanBar current version **
_G.TB = {};
--[[_G.sFromCtr = nil;
_G.STM = nil;
_G.SSS = nil;
_G.STS = nil;
_G.SCM = nil;
_G.SCMA = nil;
_G.Clock24h = nil;
_G.DNNextT = nil;
_G.ShowST = nil;
_G.ShowBT = nil;
_G.STime = nil;
_G.GTime = nil;
_G.TBFont = nil;
_G.TBTop = nil;
_G.TS = nil;
_G.ToolTipWin = nil;]]
windowOpen = true;
_G.InfamyRanks = { [0]=0, [1]=500, [2]=1250, [3]=2750, [4]=5750, [5]=14750, [6]=33500, [7]=71000, [8]=146000, [9]=258500, [10]=408500, [11]=633500, [12]=1008500, [13]=1608500, [14]=2508500, [15]=3708500 };
_G.Debug = false; -- True will enable some functions when i'm debuging


-- [FontName]={[Fontzise]=pixel needed to show one number}
_G.FontN= {
	["Arial"] = {[12]=6},
	["TrajanPro"] = {[13]=7,[14]=7,[15]=7,[16]=8,[18]=9,[19]=10,[20]=10,[21]=11,[23]=11,[24]=11,[25]=7,[26]=12,[28]=13},
	["TrajanProBold"] = {[16]=9,[22]=11,[24]=12,[25]=13,[30]=15,[36]=18},
	["Verdana"] = {[10]=5,[12]=7,[14]=8,[16]=8,[18]=12,[20]=12,[22]=12,[23]=13}
	};

-- [FontName]={[Fontzise]=pixel needed to show one letter}
_G.FontT= {
	["Arial"] = {[12]=6},
	["TrajanPro"] = {[13]=8,[14]=9,[15]=9,[16]=10,[18]=11,[19]=12,[20]=12,[21]=13,[23]=14,[24]=15,[25]=7,[26]=16,[28]=17},
	["TrajanProBold"] = {[16]=10,[22]=14,[24]=15,[25]=16,[30]=19,[36]=22},
	["Verdana"] = {[10]=5.5,[12]=7,[14]=8,[16]=9,[18]=10,[20]=11,[22]=12,[23]=12}
	};

durationarray = {572, 1722, 1067, 1678, 1101, 570, 1679, 539, 1141, 1091};

screenWidth, screenHeight = Turbine.UI.Display.GetSize();
write = Turbine.Shell.WriteLine;

--**v Get player instance v**
if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then Player = Turbine.Gameplay.LocalPlayer.GetInstance();
else Player = Turbine.Gameplay.LocalPlayer; end --EU Version without November Patch
--**

vaultpack = Player:GetVault();
sspack = Player:GetSharedStorage();
--bankpack = Player:GetBank();
bagspack = Player:GetBackpack();

PN = Player:GetName();
PlayerAlign = Player:GetAlignment(); --1: Free People / 2: Monster Play
--PlayerLink = Player:IsLinkDead();
--write("Link is: " .. tostring(PlayerLink));

AppDir = "HabnaPlugins.TitanBar";
AppDirD = AppDir..".";

AppClassD = AppDirD.."Class.";
AppCtrD = AppDirD.."Control.";
AppLocaleD = AppDirD.."Locale.";
AppRes = "HabnaPlugins/TitanBar/Resources/";

--**v Detect Game Language v**
--local tGLocale = Turbine.Engine.GetLocale() -- Not working, returning OS locale
--write(tostring(tGLocale));

GLocale = "en";
if(Turbine.Shell.IsCommand("zusatzmodule")==true) then GLocale = "de";
elseif(Turbine.Shell.IsCommand("conseil")==true) then GLocale = "fr"; end
--**^

import (AppDir);
import (AppDirD.."color");
import (AppDirD.."settings");
LoadSettings();
import (AppDirD.."functions");
import (AppDirD.."functionsCtr");
import (AppDirD.."functionsMenu");
import (AppDirD.."functionsMenuControl");
import (AppDirD.."OptionPanel"); -- LUA option panel file (for in-game plugin manager options tab)
import (AppDirD.."menu");
import (AppDirD.."menuControl");
import (AppDirD.."frmMain");
frmMain();

TitanBarCommand = Turbine.ShellCommand()

function TitanBarCommand:Execute( command, arguments )
	if ( arguments == L["SCa1"] or arguments == "opt") then
		TitanBarMenu:ShowMenu();
	elseif ( arguments == L["SCa2"] or arguments == "u" ) then
		UnloadTitanBar();
	elseif ( arguments == L["SCa3"] or arguments == "r" ) then
		ReloadTitanBar();
	elseif ( arguments == L["SCa4"] or arguments == "ra" ) then
		ResetSettings();
	elseif ( arguments == L["SCa5"] or arguments == "mi") then
		if PlayerAlign == 1 then ShowHideMoney(); else ShowNS = true; end
	elseif ( arguments == L["SCa6"] or arguments == "dp") then
		if PlayerAlign == 1 then ShowHideDestinyPoints(); else ShowNS = true; end
	elseif ( arguments == L["SCa7"] or arguments == "bi" ) then
		ShowHideBackpackInfos();
	elseif ( arguments == L["SCa8"] or arguments == "pi" ) then
		ShowHidePlayerInfos();
	elseif ( arguments == L["SCa9"] or arguments == "ei" ) then
		if PlayerAlign == 1 then ShowHideEquipInfos(); else ShowNS = true; end
	elseif ( arguments == L["SCa10"] or arguments == "di" ) then
		if PlayerAlign == 1 then  ShowHideDurabilityInfos(); else ShowNS = true; end
	elseif ( arguments == L["SCa11"] or arguments == "pl" ) then
		ShowHidePlayerLoc();
	elseif ( arguments == L["SCa12"] or arguments == "gt" ) then
		ShowHideGameTime();
	elseif ( arguments == L["SCa13"] or arguments == "?" or arguments == "sc" ) then
		HelpInfo();
	elseif ( arguments == L["SCa14"] or arguments == "IF") then
		if PlayerAlign == 1 then ShowHideShards(); else ShowNS = true; end
	elseif ( arguments == L["SCa15"] or arguments == "sm") then
		if PlayerAlign == 1 then ShowHideSkirmishMarks(); else ShowNS = true; end
	elseif ( arguments == L["SCa16"] or arguments == "mp") then
		if PlayerAlign == 1 then ShowHideMedallions(); else ShowNS = true; end
	elseif ( arguments == L["SCa17"] or arguments == "sl") then
		if PlayerAlign == 1 then ShowHideSeals(); else ShowNS = true; end
	elseif ( arguments == L["SCa18"] or arguments == "cp") then
		ShowHideCommendations();
	elseif ( arguments == L["SCa19"] or arguments == "ir" ) then
		ShowHideInfamy();
	elseif ( arguments == L["SCa20"] or arguments == "vt" ) then
		if PlayerAlign == 1 then ShowHideVault(); else ShowNS = true; end
	elseif ( arguments == L["SCa21"] or arguments == "ss" ) then
		if PlayerAlign == 1 then ShowHideSharedStorage(); else ShowNS = true; end
	elseif ( arguments == L["SCa22"] or arguments == "dn" ) then
		if PlayerAlign == 1 then ShowHideDayNight(); else ShowNS = true; end
	elseif ( arguments == L["SCa23"] or arguments == "ti" ) then
		if PlayerAlign == 1 then ShowHideTrackItems(); else ShowNS = true; end
	--elseif ( arguments == L["SCa??"] or arguments == "bk" ) then
		--if PlayerAlign == 1 then ShowHideBank(); else ShowNS = true; end
	--elseif ( arguments == L["SCa??"] or arguments == "ab") then
		--AboutTitanBar();
	elseif ( arguments == "pw" ) then
		write("");
		write("This is your currency:");
		write("-----v----------------------");
		ShowTableContent(PlayerCurrency);
		write("-----^----------------------");
		write("You may request to add a currency if it's not listed in the wallet menu! Give the 'key' string to Habna so it can be added into futur version of TitanBar thx!");
		write("");
	else
		ShowNS = true;
	end

	if ShowNS then write( "TitanBar: " .. L["SC0"] ); ShowNS = nil; end -- Command not supported
end

Turbine.Shell.AddCommand('TitanBar', TitanBarCommand)

Turbine.Plugin.Load = function( self, sender, args )
	--write( L["TBLang"] ); --TitanBar Language
	--write( L["TBLoad"] ); --TitanBar version by Habna loaded!
end

Turbine.Plugin.Unload = function( self, sender, args )
	--write("Unloading TitanBar");
	SavePlayerBags();
end