-- BagInfosWindow.lua
-- written by Habna


function frmBagInfos()
	frmBI = true;
	tbagspack = bagspack;
	SelCN = PN;
	import (AppClassD.."DropDown");
	wBagInfos = Turbine.UI.Lotro.Window()

	-- **v Set some window stuff v**
	wBagInfos:SetText( L["BIh"] );
	wBagInfos:SetPosition( BIWLeft, BIWTop );
	wBagInfos:SetSize( 390, 472 );
	wBagInfos:SetWantsKeyEvents( true );
	wBagInfos:SetVisible( true );
	--wBagInfos:SetZOrder( 2 );
	--wBagInfos:Activate();

	wBagInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wBagInfos:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wBagInfos:SetVisible( not wBagInfos:IsVisible() );
		end
	end

	wBagInfos.MouseUp = function( sender, args )
		settings.BagInfos.L = string.format("%.0f", wBagInfos:GetLeft());
		settings.BagInfos.T = string.format("%.0f", wBagInfos:GetTop());
		BIWLeft, BIWTop = wBagInfos:GetPosition();
		SaveSettings( false );
	end

	wBagInfos.Closing = function( sender, args ) -- Function for the Upper right X icon
		wBagInfos:SetWantsKeyEvents( false );
		RemoveCallback( tbagspack, "ItemAdded" );
		RemoveCallback( tbagspack, "ItemRemoved" );
		wBagInfos = nil;
		frmBI = nil;
	end
	-- **^
	-- **v Character name - label & DropDown box v**
	local newt = {}
	for i, v in pairs(PlayerBags) do table.insert(newt,i);  end
	table.sort(newt);

	PNDD = DropDown.Create( newt, PN );
	PNDD:SetParent( wBagInfos );
	PNDD:SetMaxItems( 5 );
	PNDD:SetPosition( 15, 35 );

	PNDD.ItemChanged = function () -- The event that's executed when a menu item is clicked.
		SelCN = PNDD:GetText();
		bagspackCount = 0;
		for k, v in pairs(PlayerBags[SelCN]) do bagspackCount = bagspackCount + 1; end
		SetBagsPack(SelCN);
	end
	-- **^
	-- **v Set the itemlistbox border v**
	wBagInfos.ListBoxBorder = Turbine.UI.Control();
	wBagInfos.ListBoxBorder:SetParent( wBagInfos );
	wBagInfos.ListBoxBorder:SetPosition( 15, 60 );
	wBagInfos.ListBoxBorder:SetSize( wBagInfos:GetWidth()-30, 390 );
	wBagInfos.ListBoxBorder:SetBackColor( Color["grey"] );
	wBagInfos.ListBoxBorder:SetVisible( true );
	-- **^
	-- **v Set the itemlistbox v**
	wBagInfos.ListBox = Turbine.UI.ListBox();
	wBagInfos.ListBox:SetParent( wBagInfos );
	wBagInfos.ListBox:SetPosition( wBagInfos.ListBoxBorder:GetLeft() + 2, wBagInfos.ListBoxBorder:GetTop() + 2 );
	wBagInfos.ListBox:SetSize( wBagInfos.ListBoxBorder:GetWidth() - 4, wBagInfos.ListBoxBorder:GetHeight() - 4 );
	wBagInfos.ListBox:SetMaxItemsPerLine( 1 );
	wBagInfos.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wBagInfos.ListBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	-- **^
	-- **v Set the scrollbar v**
	wBagInfos.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	--wBagInfos.ListBoxScrollBar:SetParent( wBagInfos );
	wBagInfos.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wBagInfos.ListBox:SetVerticalScrollBar( wBagInfos.ListBoxScrollBar );
	wBagInfos.ListBoxScrollBar:SetPosition( wBagInfos:GetWidth()-28, wBagInfos.ListBox:GetTop() + 2 );
	wBagInfos.ListBoxScrollBar:SetSize( 10, wBagInfos.ListBox:GetHeight() - 2 );
	-- **^
	
	SavePlayerBags();

	bagspackCount = 0;
	if PlayerBags[PN] ~= nil then for k, v in pairs(PlayerBags[PN]) do bagspackCount = bagspackCount + 1; end end

	if bagspackCount == 0 then --Bags list empty
		wBagInfos.ListBoxBorder:SetVisible( false );
		wBagInfos.ListBox:SetVisible( false );

		local lblmgs = Turbine.UI.Label();
		lblmgs:SetParent( wBagInfos );
		lblmgs:SetText( L["MNeed"]..L["VTh"]..L["MOnce"] );
		lblmgs:SetPosition( 17, 40 );
		lblmgs:SetSize( wBagInfos:GetWidth()-32, 39 );
		lblmgs:SetForeColor( Color["green"] );
		lblmgs:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

		wBagInfos.ListBoxBorder:SetHeight( lblmgs:GetHeight()+8 );
		wBagInfos.ListBox:SetHeight( lblmgs:GetHeight()+4 );
		wBagInfos:SetHeight( lblmgs:GetHeight()+65 );
	else
		wBagInfos.ListBoxScrollBar:SetParent( wBagInfos );
		--vaultpackSize = tonumber(PlayerBags[PN]["1"].Z);
		--vaultpackCount = tvaultpack:GetCount();
		SetBagsPack(SelCN);
	end
	
	AddCallback(tbagspack, "ItemAdded", 
		function(sender, args)
		if frmBI then
			bagspackCount = 0;
			if SelCN == PN then
				SavePlayerBags();
				bagspackCount = 0;
				if PlayerBags[PN] ~= nil then for k, v in pairs(PlayerBags[PN]) do bagspackCount = bagspackCount + 1; end end
				SetBagsPack(SelCN);
			end
		end
	end);

	--**v Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue) v**
	BIItemRemovedTimer = Turbine.UI.Control();
	BIItemRemovedTimer.Update = function( sender, args )
		BIItemRemovedTimer:SetWantsUpdates( false );
		if frmBI then
			bagspackCount = 0;
			if SelCN == PN then
				SavePlayerBags();
				bagspackCount = 0;
				if PlayerBags[PN] ~= nil then for k, v in pairs(PlayerBags[PN]) do bagspackCount = bagspackCount + 1; end end
				SetBagsPack(SelCN);
			end
		end
	end

	AddCallback(tbagspack, "ItemRemoved", function(sender, args) BIItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround
end

function SetBagsPack(PN)
	wBagInfos.ListBox:ClearItems();
	itemCtl = {};
	--Turbine.UI.Lotro.ItemControl( Backpack:GetItem( i ) );
	for i = 1, bagspackCount do
		-- Item control
		itemCtl[i] = Turbine.UI.Control();
		itemCtl[i]:SetSize( wBagInfos.ListBox:GetWidth()-12, 35 );

		-- Item Background/Underlay/Shadow/Image
		local itemBG = Turbine.UI.Control();
		itemBG:SetParent( itemCtl[i] );
		itemBG:SetSize( 32, 32 );
		itemBG:SetPosition( 3, 3 );
		itemBG:SetBackground(tonumber(PlayerBags[PN][tostring(i)].B));
		itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
		local itemU = Turbine.UI.Control();
		itemU:SetParent( itemCtl[i] );
		itemU:SetSize( 32, 32 );
		itemU:SetPosition( 3, 3 );
		itemU:SetBackground(tonumber(PlayerBags[PN][tostring(i)].U));
		itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		local itemS = Turbine.UI.Control();
		itemS:SetParent( itemCtl[i] );
		itemS:SetSize( 32, 32 );
		itemS:SetPosition( 3, 3 );
		itemS:SetBackground(tonumber(PlayerBags[PN][tostring(i)].S));
		itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		local item = Turbine.UI.Control();
		item:SetParent( itemCtl[i] );
		item:SetSize( 32, 32 );
		item:SetPosition( 3, 3 );
		item:SetBackground(tonumber(PlayerBags[PN][tostring(i)].I));
		item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Item Quantity
		local itemQTE = Turbine.UI.Label();
		itemQTE:SetParent( itemCtl[i] );
		itemQTE:SetSize( 32, 15 );
		itemQTE:SetPosition( -4, 16 );
		itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
		itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
		itemQTE:SetOutlineColor( Color["black"] );
		itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
		itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
		itemQTE:SetForeColor( Color["nicegold"] );
		itemQTE:SetText(tonumber(PlayerBags[PN][tostring(i)].N));

		-- Item name
		local itemLbl = Turbine.UI.Label();
		itemLbl:SetParent( itemCtl[i] );
		itemLbl:SetSize( itemCtl[i]:GetWidth() - 35, 35 );
		itemLbl:SetPosition( 37, 2 );
		itemLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		itemLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		itemLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
		itemLbl:SetForeColor( Color["white"] );
		itemLbl:SetText( PlayerBags[PN][tostring(i)].T );

		wBagInfos.ListBox:AddItem( itemCtl[i] );
	end

	-- Set window title
	--wBagInfos:SetText( L["MBI"] .. " - " .. L["VTFree"] .. ( bagspackSize - bagspackCount ) .. L["VTUsed"] .. bagspackCount .. L["VTMax"] .. bagspackSize );
end