-- functionsCtr.lua
-- Written By Habna


function ImportCtr( value )
	if value == "MI" then --Money Infos
		import (AppCtrD.."MoneyInfos");
		import (AppCtrD.."MoneyInfosToolTip");
		PlayerAtt = Player:GetAttributes();
		AddCallback(PlayerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		UpdateMoney();
		MI["Ctr"]:SetPosition( _G.MILocX, _G.MILocY );
	elseif value == "DP" then --Destiny Points
		import (AppCtrD.."DestinyPoints");
		PlayerAtt = Player:GetAttributes();
		AddCallback(PlayerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		UpdateDestinyPoints();
		DP["Ctr"]:SetPosition( _G.DPLocX, _G.DPLocY );
	elseif value == "SP" then --Shards
		import (AppCtrD.."Shards");
		--LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Shard"];
		--AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateShards(); end);
		UpdateShards();
		SP["Ctr"]:SetPosition( _G.SPLocX, _G.SPLocY );
	elseif value == "SM" then --Skirmish Marks
		import (AppCtrD.."SkirmishMarks");
		--LoadPlayerWallet();
		--PlayerMark = PlayerCurrency["Mark"];
		--AddCallback(PlayerMark, "QuantityChanged", function(sender, args) UpdateMarks(); end);
		UpdateMarks();
		SM["Ctr"]:SetPosition( _G.SMLocX, _G.SMLocY );
	elseif value == "MP" then --Medallions
		import (AppCtrD.."Medallions");
		--LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Medallion"];
		--AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateMedallions(); end);
		UpdateMedallions();
		MP["Ctr"]:SetPosition( _G.MPLocX, _G.MPLocY );
	elseif value == "SL" then --Seals
		import (AppCtrD.."Seals");
		--LoadPlayerWallet();
		--PlayerSeals = PlayerCurrency["Seals"];
		--AddCallback(PlayerSeals, "QuantityChanged", function(sender, args) UpdateSeals(); end);
		UpdateSeals();
		SL["Ctr"]:SetPosition( _G.SLLocX, _G.SLLocY );
	elseif value == "CP" then --Commendations
		import (AppCtrD.."Commendations");
		--LoadPlayerWallet();
		--PlayerCommendation = PlayerCurrency["Commendation"];
		--AddCallback(PlayerCommendation, "QuantityChanged", function(sender, args) UpdateCommendations(); end);
		UpdateCommendations();
		CP["Ctr"]:SetPosition( _G.CPLocX, _G.CPLocY );
	elseif value == "BI" then --Backpack Infos
		import (AppCtrD.."BagInfos");
		--import (AppCtrD.."BagInfosToolTip");
		--Backpack = Player:GetBackpack();
		AddCallback(bagspack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		AddCallback(bagspack, "ItemRemoved", function(sender, args) ItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround
		--AddCallback(bagspack, "ItemRemoved", function(sender, args) UpdateBackpackInfos(); end);
		UpdateBackpackInfos();
		BI["Ctr"]:SetPosition( _G.BILocX, _G.BILocY );
	elseif value == "PI" then --Player Infos
		import (AppCtrD.."PlayerInfos");
		import (AppCtrD.."PlayerInfosToolTip");
		AddCallback(Player, "LevelChanged", function(sender, args) PI["Lvl"]:SetText( Player:GetLevel() ); end);
		AddCallback(Player, "NameChanged", function(sender, args) PI["Name"]:SetText( Player:GetName() ); end);
		UpdatePlayersInfos();
		PI["Ctr"]:SetPosition( _G.PILocX, _G.PILocY );
	elseif value == "DI" then --Durability Infos
		import (AppCtrD.."DurabilityInfos");
		import (AppCtrD.."DurabilityInfosToolTip");
		UpdateDurabilityInfos();
		DI["Ctr"]:SetPosition( _G.DILocX, _G.DILocY );
	elseif value == "EI" then --Equipment Infos
		import (AppCtrD.."EquipInfos");
		import (AppCtrD.."EquipInfosToolTip");
		UpdateEquipsInfos();
		EI["Ctr"]:SetPosition( _G.EILocX, _G.EILocY );
	elseif value == "PL" then --Player Location
		import (AppCtrD.."PlayerLoc");
		AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			aMess = args.Message;

			----                1111111111222222222233333333 
			----       1234567890123456789012345678901234567
			--sMess = "Entered the Bree-town - Trade channel";

			if aMess ~= nil then
				if GLocale == "en" then aS, aE = "Entered the ", "-%s";
				elseif GLocale == "fr" then aS, aE = "Canal ", "-%s";
				elseif GLocale == "de" then aS, aE = "Kanal '", "-%s"; end

				local as,ae = string.find(aMess, aS);
				if as ~= nil then
					local afirst = ae + 1;
					local bs,be = string.find(aMess, aE);
					if bs ~= nil then
						local alast = bs - 2;
						-- Extract Location from args.Message
						--write("'".. pLLoc .. "'"); -- debug purpose
						pLLoc = string.sub( aMess, afirst, alast );
						UpdatePlayerLoc( pLLoc );
						settings.PlayerLoc.L = pLLoc;
						SaveSettings( false );
						--write("'"..pLLoc.."'"); --debug purpose
					end
				end
			end
		end);
		UpdatePlayerLoc( pLLoc );
		PL["Ctr"]:SetPosition( _G.PLLocX, _G.PLLocY );
	elseif value == "TI" then --Track Items
		import (AppCtrD.."TrackItems");
		import (AppCtrD.."TrackItemsToolTip");
		UpdateTrackItems();
		TI["Ctr"]:SetPosition( _G.TILocX, _G.TILocY );
	elseif value == "IF" then --Infamy
		import (AppCtrD.."Infamy");
		import (AppCtrD.."InfamyToolTip");
		---InfamyCount = Turbine.
		--AddCallback(InfamyCount, "QuantityChanged", function(sender, args) UpdateInfamy(); end);
		AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			if args.ChatType == Turbine.ChatType.Advancement then
				bMess = args.Message;
				--GLocale = "en"; --debug purpose
				----                1111111111222222222233333333 
				----       1234567890123456789012345678901234567
				--bMess = "You've earned 40 infamy points."; --debug purpose
				--bMess = "You've earned 40 renown points."; --debug purpose
				--bMess = "Vous avez gagn\195\169 60 points d'infamie"; --debug purpose
				--bMess = "Ihr habt 80 Verrufenheitspunkte erhalten."; --debug purpose

				if bMess ~= nil then
					if GLocale == "fr" then bS, bE = "Vous avez gagn\195\169", "points"; end

					if PlayerAlign == 1 then
						if GLocale == "en" then bS, bE = "You've earned", "renown";
						--elseif GLocale == "fr" then bS, bE = "Vous avez gagn\195\169", "points renomm\195\169e";
						elseif GLocale == "de" then bS, bE = "Ihr habt ", "Ansehenspunkte"; end
					else
						if GLocale == "en" then bS, bE = "You've earned", "infamy";
						--elseif GLocale == "fr" then bS, bE = "Vous avez gagn\195\169", "points d'infamie";
						elseif GLocale == "de" then bS, bE = "Ihr habt", "Verrufenheitspunkte"; end
					end

					local cs,ce = string.find(bMess, bS);
					if cs ~= nil then
						local bfirst = ce + 1;
						local ds,de = string.find(bMess, bE);
						if ds ~= nil then
							local blast = ds - 1;
							-- Extract earned points from args.Message
							local pIPTS = string.sub( bMess, bfirst, blast );
						
							InfamyPTS = InfamyPTS + pIPTS;
						
							for i=0, 14 do
								if tonumber(InfamyPTS) >= InfamyRanks[i] and tonumber(InfamyPTS) < InfamyRanks[i+1] then InfamyRank = i; break end
							end

							settings.Infamy.P = InfamyPTS;
							settings.Infamy.K = InfamyRank;

							SaveSettings( false );
						end
					end
				end
			end
		end);
		UpdateInfamy();
		IF["Ctr"]:SetPosition( _G.IFLocX, _G.IFLocY );
	elseif value == "BK" then --Bank
		--import (AppCtrD.."Bank");
		--import (AppCtrD.."BankToolTip");
		--UpdateBank();
		--BK["Ctr"]:SetPosition( _G.BKLocX, _G.BKLocY );
	elseif value == "DN" then --Day & Night Time
		import (AppCtrD.."DayNight");
		--import (AppCtrD.."DayNightToolTip");
		UpdateDayNight();
		DN["Ctr"]:SetPosition( _G.DNLocX, _G.DNLocY );
	elseif value == "GT" then --Game Time
		import (AppCtrD.."GameTime");
		--import (AppCtrD.."GameTimeToolTip");
		--PlayerTime = Turbine.Engine.GetDate();
		--AddCallback(PlayerTime, "MinuteChanged", function(sender, args) UpdateGameTime(); end);
		if _G.ShowBT then UpdateGameTime("bt");
		elseif _G.ShowST then UpdateGameTime("st");
		else UpdateGameTime("gt") end
		GT["Ctr"]:SetPosition( _G.GTLocX, _G.GTLocY );
	elseif value == "VT" then --Vault
		import (AppCtrD.."Vault");
		--import (AppCtrD.."VaultToolTip");
		--AddCallback(vaultpack, "SizeChanged", function(sender, args) SavePlayerVault(); end);
		AddCallback(vaultpack, "CountChanged", function(sender, args) SavePlayerVault(); end);
		UpdateVault();
		VT["Ctr"]:SetPosition( _G.VTLocX, _G.VTLocY );
	elseif value == "SS" then --Shared Storage
		import (AppCtrD.."SharedStorage");
		--import (AppCtrD.."SharedStorageToolTip");
		--AddCallback(sspack, "SizeChanged", function(sender, args) SavePlayerVault(); end);
		AddCallback(sspack, "CountChanged", function(sender, args) SavePlayerSharedStorage(); end);
		UpdateSharedStorage();
		SS["Ctr"]:SetPosition( _G.SSLocX, _G.SSLocY );
	end
end

function GetEquipmentInfos()
	LoadEquipmentTable();
	PlayerEquipment = Player:GetEquipment();
	if PlayerEquipment == nil then return end --Remove when Player Equipment info are available before plugin is loaded

	itemEquip = {};
	itemScore, numItems = 0, 0;
	
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item Name, WearState, Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = PlayerEquipItem:GetName();
			local Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Quality = Quality;
			local Durability = PlayerEquipItem:GetDurability();
			itemEquip[i].Durability = Durability;
			itemEquip[i].Item = true;

			if Quality == 5 then itemScore = 50; end -- Common
			if Quality == 4 then itemScore = 100; end -- Uncommon
			if Quality == 3 then itemScore = 150; end -- Incomparable
			if Quality == 2 then itemScore = 200; end -- Rare
			if Quality == 1 then itemScore = 250; end -- Legendary
			if Quality == 0 then itemScore = 0; end -- undefined
		
			if Durability == 0 then itemEquip[i].ItemPts = itemScore + 0; end -- undefined
			if Durability == 7 then itemEquip[i].ItemPts = itemScore + 5; end -- Weak / Faible
			if Durability == 1 then itemEquip[i].ItemPts = itemScore + 10; end -- Substantial
			if Durability == 2 then itemEquip[i].ItemPts = itemScore + 20; end -- Brittle / Fragile
			if Durability == 3 then itemEquip[i].ItemPts = itemScore + 30; end -- Normal
			if Durability == 4 then itemEquip[i].ItemPts = itemScore + 40; end -- Tought / Robuste
			if Durability == 5 then itemEquip[i].ItemPts = itemScore + 50; end -- Flimsy / Fragile ??
			if Durability == 6 then itemEquip[i].ItemPts = itemScore + 60; end -- Indestructible
			
			itemEquip[i].BImgID = PlayerEquipItem:GetBackgroundImageID();
			itemEquip[i].QImgID = PlayerEquipItem:GetQualityImageID();
			itemEquip[i].UImgID = PlayerEquipItem:GetUnderlayImageID();
			itemEquip[i].SImgID = PlayerEquipItem:GetShadowImageID();
			itemEquip[i].IImgID = PlayerEquipItem:GetIconImageID();

			WearState = PlayerEquipItem:GetWearState();
			itemEquip[i].WearState = WearState;
			if WearState ~= 0 then numItems = numItems + 1; end -- Undefined item must not be count (Pocket item are as Undefined Wear State, they are indestructible)
			--Quality ~= 5 and Durability ~= 6 and 
			
			if WearState == 2 then itemEquip[i].ItemDurPts = 100; end -- Pristine / parfait
			if WearState == 4 then itemEquip[i].ItemDurPts = 75; end -- Worn / us
			if WearState == 1 then itemEquip[i].ItemDurPts = 50; end -- Damaged / endommag
			if WearState == 3 then itemEquip[i].ItemDurPts = 0; end -- Broken / cass
			if WearState == 0 then itemEquip[i].ItemDurPts = 0; end -- undefined
			
			itemEquip[i].wsHandler = AddCallback(PlayerEquipItem, "WearStateChanged", function(sender, args) ChangeWearState(i); end);
			--itemEquip[i].ieHandler = AddCallback(PlayerEquipItem, "ItemEquipped", function(sender, args) UpdateEquipsInfos(i); end); --Add when each item can trigger this event
			--itemEquip[i].iuHandler = AddCallback(PlayerEquipItem, "ItemUnequipped", function(sender, args) UpdateEquipsInfos(i); end); --Add when each item can trigger this event
		else
			itemEquip[i].Name = "zEmpty";
			itemEquip[i].WearState = 0;
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
			itemEquip[i].ItemPts = 0;
			itemEquip[i].ItemDurPts = 0;
			itemEquip[i].Item = false;
		end
	end
end

function CalculateAllItemsDurability()
	itemsTotDurability = 0;

	for i = 1, 20 do
		itemsTotDurability = itemsTotDurability + itemEquip[i].ItemDurPts;
	end
	
	if numItems == 0 then itemsTotDurability = 100;
	else itemsTotDurability = itemsTotDurability / numItems; end
end

function CalculateAllItemsScore()
	itemTotScore = 0;

	for i = 1, 20 do
		itemTotScore = itemTotScore + itemEquip[i].ItemPts;
	end
end

function LoadPlayerItemTrackingList()
	if GLocale == "de" then	ITL = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingListDE" ); end
	if GLocale == "en" then ITL = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingListEN" ); end
	if GLocale == "fr" then	ITL = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingListFR" ); end
	
	if ITL == nil then ITL = {}; end
end

function SavePlayerItemTrackingList(ITL)
	local newt = {};
	for k, v in pairs(ITL) do newt[tostring(k)] = v; end
	ITL = newt;

	if GLocale == "de" then	Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingListDE", ITL ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingListEN", ITL ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingListFR", ITL ); end
end

function LoadPlayerMoney()
	wallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarPlayerWallet" );

	if wallet == nil then wallet = {}; end

	local PN = Player:GetName();
	local PlayerAtt = Player:GetAttributes();

	if wallet[PN] == nil then wallet[PN] = {}; end
	if wallet[PN].Show == nil then wallet[PN].Show = true; end
	if wallet[PN].ShowToAll == nil then wallet[PN].ShowToAll = true; end
	_G.SCM = wallet[PN].Show;
	_G.SCMA = wallet[PN].ShowToAll;

	--Convert wallet
	local tGold, tSilver, tCopper, bOk;
	for k,v in pairs(wallet) do
		if wallet[k].Gold ~= nil then bOk = true; tGold = tonumber(wallet[k].Gold); wallet[k].Gold = nil; end --(Remove this line after: August 18th 2012)
		if wallet[k].Silver ~= nil then bOk = true; tSilver = tonumber(wallet[k].Silver); wallet[k].Silver = nil;end --(Remove this line after: August 18th 2012)
		if wallet[k].Copper ~= nil then bOk = true; tCopper = tonumber(wallet[k].Copper); wallet[k].Copper = nil;
		if tCopper < 10 then tCopper = "0".. tCopper; end end --(Remove this line after: August 18th 2012)

		if bOk then
			local strdata;
			if tGold == 0 then
				if tSilver == 0 then
					strdata = tCopper;
				else
					strdata = tSilver..tCopper;
				end
			else
				if tSilver == 0 then
					strdata = tGold.."000"..tCopper;
				else
					strdata = tGold..tSilver..tCopper;
				end
			end
			wallet[k].Money = tostring(strdata);
		end
	end
	--
	--Statistics section
	local DDate = Turbine.Engine.GetDate();
	DOY = tostring(DDate.DayOfYear);
	walletStats = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarPlayerWalletStats" );
	if walletStats == nil then walletStats = {};
	else for k,v in pairs(walletStats) do if k ~= DOY then walletStats[k] = nil; end end end --Delete old date entry
	if walletStats[DOY] == nil then walletStats[DOY] = {}; end
	if walletStats[DOY][PN] == nil then walletStats[DOY][PN] = {};
		walletStats[DOY][PN].TotEarned = "0";
		walletStats[DOY][PN].TotSpent = "0";
		walletStats[DOY][PN].SumTS = "0";
	end
	walletStats[DOY][PN].Start = tostring(PlayerAtt:GetMoney());
	walletStats[DOY][PN].Had = tostring(PlayerAtt:GetMoney());
	walletStats[DOY][PN].Earned = "0";
	walletStats[DOY][PN].Spent = "0";
	walletStats[DOY][PN].SumSS = "0";
	--

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarPlayerWalletStats", walletStats );
end

-- **v Save player wallet infos v**
function SavePlayerMoney(str)
	local PN = Player:GetName();
	
	if string.sub( PN, 1, 1 ) == "~" then return end; --Ignore session play character

	wallet[PN].Show = _G.SCM;
	wallet[PN].ShowToAll = _G.SCMA;
	wallet[PN].Money = tostring(PlayerAtt:GetMoney());

	-- Calculate Gold/Silver/Copper Total
	if wallet.Total ~= nil then wallet.Total = nil; end --(Remove this line after: August 18th 2012)
	GoldTot, SilverTot, CopperTot = 0, 0, 0;
	gold, silver, copper = 0, 0, 0;
	
	for k,v in pairs(wallet) do
		DecryptMoney(v.Money);
		if k == PN then
			if v.Show then
				GoldTot = GoldTot + gold;
				SilverTot = SilverTot + silver;
				CopperTot = CopperTot + copper;
			end
		else
			if v.ShowToAll or v.ShowToAll == nil then
				GoldTot = GoldTot + gold;
				SilverTot = SilverTot + silver;
				CopperTot = CopperTot + copper;
			end
		end
	end

	--************************************************************************
	if (string.len(CopperTot)==3) then
		local CopperTotX = CopperTot;
		SilverTot = SilverTot + string.sub(CopperTotX,1,-3);
		CopperTot = string.sub(CopperTot,2,-1);
	end
		
	if (string.len(SilverTot)==4) then
		local SilverTotX = SilverTot;
		GoldTot = GoldTot + string.sub(SilverTotX,1,-4);
		SilverTot = string.sub(SilverTot,2,-1);
	end
	--************************************************************************

	--wallet.Total.Gold = string.format("%.0f", GoldTot)
	--wallet.Total.Silver = string.format("%.0f", SilverTot)
	--wallet.Total.Copper = string.format("%.0f", CopperTot)

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarPlayerWallet", wallet );
end
-- **^

function LoadPlayerWallet()
	PlayerWallet = Player:GetWallet();
	PlayerWalletSize = PlayerWallet:GetSize();
	--write(tostring(PlayerWalletSize));
	if PlayerWalletSize == 0 then return end --Remove when Wallet info are available before plugin is loaded
	
	for i = 1, PlayerWalletSize do
		local CurItem = PlayerWallet:GetItem(i);
		local CurName = PlayerWallet:GetItem(i):GetName();

		PlayerCurrency[CurName] = CurItem;
		if PlayerCurrencyHandler[CurName] == nil then PlayerCurrencyHandler[CurName] = AddCallback(PlayerCurrency[CurName], "QuantityChanged", function(sender, args) UpdateCurrency(CurName); end); end
	end
end

function LoadPlayerVault()
	PlayerVault = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarVault" );
	if PlayerVault == nil then PlayerVault = {}; end
	if PlayerVault[PN] == nil then PlayerVault[PN] = {}; end
end

function SavePlayerVault()
	vaultpackSize = vaultpack:GetCapacity();
	vaultpackCount = vaultpack:GetCount();

	PlayerVault[PN] = {};

	for ii = 1, vaultpackCount do
		PlayerVault[PN][tostring(ii)] = vaultpack:GetItem( ii );
		local iteminfo = PlayerVault[PN][tostring(ii)]:GetItemInfo();
			
		PlayerVault[PN][tostring(ii)].Q = tostring(iteminfo:GetQualityImageID());
		PlayerVault[PN][tostring(ii)].B = tostring(iteminfo:GetBackgroundImageID());
		PlayerVault[PN][tostring(ii)].U = tostring(iteminfo:GetUnderlayImageID());
		PlayerVault[PN][tostring(ii)].S = tostring(iteminfo:GetShadowImageID());
		PlayerVault[PN][tostring(ii)].I = tostring(iteminfo:GetIconImageID());
		PlayerVault[PN][tostring(ii)].T = tostring(iteminfo:GetName());
		local tq = tostring(PlayerVault[PN][tostring(ii)]:GetQuantity());
		if tq == "1" then tq = ""; end
		PlayerVault[PN][tostring(ii)].N = tq;
		PlayerVault[PN][tostring(ii)].Z = tostring(vaultpackSize);
	end

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarVault", PlayerVault );
end

function LoadPlayerSharedStorage()
	PlayerSharedStorage = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarSharedSrorage" );
	if PlayerSharedStorage == nil then PlayerSharedStorage = {}; end
end

function SavePlayerSharedStorage()
	sspackSize = sspack:GetCapacity();
	sspackCount = sspack:GetCount();

	PlayerSharedStorage = {};

	for ii = 1, sspackCount do
		PlayerSharedStorage[tostring(ii)] = sspack:GetItem( ii );
		local iteminfo = PlayerSharedStorage[tostring(ii)]:GetItemInfo();
			
		PlayerSharedStorage[tostring(ii)].Q = tostring(iteminfo:GetQualityImageID());
		PlayerSharedStorage[tostring(ii)].B = tostring(iteminfo:GetBackgroundImageID());
		PlayerSharedStorage[tostring(ii)].U = tostring(iteminfo:GetUnderlayImageID());
		PlayerSharedStorage[tostring(ii)].S = tostring(iteminfo:GetShadowImageID());
		PlayerSharedStorage[tostring(ii)].I = tostring(iteminfo:GetIconImageID());
		PlayerSharedStorage[tostring(ii)].T = tostring(iteminfo:GetName());
		local tq = tostring(PlayerSharedStorage[tostring(ii)]:GetQuantity());
		if tq == "1" then tq = ""; end
		PlayerSharedStorage[tostring(ii)].N = tq;
		PlayerSharedStorage[tostring(ii)].Z = tostring(sspackSize);
	end

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarSharedSrorage", PlayerSharedStorage );
end

function LoadPlayerBags()
	PlayerBags = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarBags" );
	if PlayerBags == nil then PlayerBags = {}; end
	if PlayerBags[PN] == nil then PlayerBags[PN] = {}; end
end

function SavePlayerBags()
	bagspackSize = bagspack:GetSize();

	PlayerBags[PN] = {};
	ii=1;
	for i = 1, bagspackSize do
		
		local items = bagspack:GetItem( i );
		
		if items ~= nil then
			PlayerBags[PN][tostring(ii)] = items;
			local iteminfo = PlayerBags[PN][tostring(ii)]:GetItemInfo();

			PlayerBags[PN][tostring(ii)].Q = tostring(iteminfo:GetQualityImageID());
			PlayerBags[PN][tostring(ii)].B = tostring(iteminfo:GetBackgroundImageID());
			PlayerBags[PN][tostring(ii)].U = tostring(iteminfo:GetUnderlayImageID());
			PlayerBags[PN][tostring(ii)].S = tostring(iteminfo:GetShadowImageID());
			PlayerBags[PN][tostring(ii)].I = tostring(iteminfo:GetIconImageID());
			PlayerBags[PN][tostring(ii)].T = tostring(iteminfo:GetName());
			local tq = tostring(PlayerBags[PN][tostring(ii)]:GetQuantity());
			if tq == "1" then tq = ""; end
			PlayerBags[PN][tostring(ii)].N = tq;
			PlayerBags[PN][tostring(ii)].Z = tostring(bagspackSize);

			ii = ii +1;
		end
	end

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarBags", PlayerBags );
end

function LoadPlayerBank()
	
end

function SavePlayerBank()

end

function UpdateCurrency(str)
	if str == pwShard and ShowShards then UpdateShards(); end
	if str == pwMark and ShowSkirmishMarks then UpdateMarks(); end
	if str == pwMedallion and ShowMedallions then UpdateMedallions(); end
	if str == pwSeal and ShowSeals then UpdateSeals(); end
	if str == pwCommendation and ShowCommendations then UpdateCommendations(); end
end

function GetCurrency(str)
	CurQuantity = 0;
	
	for k,v in pairs(PlayerCurrency) do
		if k == str then
			CurQuantity = PlayerCurrency[str]:GetQuantity();
			break
		end
	end
	
	return CurQuantity
end